function onAccept()
{
    var usePopup = document.getElementById("delicious-prefs-popup").checked;
	try
	{    
		deliciousService.setUsePopup(usePopup)
	}
	catch(e)
	{
		alert(e);
		return false;
	}
    nsPreferences.setBoolPref(deliciousService.useExperimentalKey, document.getElementById("delicious-prefs-experimental").checked);
    nsPreferences.setBoolPref(cookies.enableCookieManagementKey, document.getElementById("delicious-prefs-cookie-management").checked);
    return true;
}

function onLoad()
{
//TODO Move nsPreferences things to a prefs module.
    var usePopup = nsPreferences.getBoolPref(deliciousService.usePopupKey, true);
    document.getElementById("delicious-prefs-popup").checked = usePopup;
    
    var cookiesEnabled = nsPreferences.getBoolPref(cookies.enableCookieManagementKey, true);
    document.getElementById("delicious-prefs-cookie-management").checked = cookiesEnabled;
    if (cookiesEnabled) {
        document.getElementById("delicious-prefs-experimental").checked = nsPreferences.getBoolPref(deliciousService.useExperimentalKey, true);
    } else {
        document.getElementById("delicious-prefs-experimental").disabled = true;
    }

    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    var users = userManager.getUsers();
    var defaultUser = userManager.getDefaultUser();
    for (user in users) {
        var li = accountListbox.appendItem(userManager.getAccountNameForUser(users[user]), users[user]);
        var lc = document.createElement('listcell');
        lc.setAttribute("class", "listcell-iconic");
        if (users[user] == defaultUser) {
            lc.setAttribute("image", "chrome://mozapps/skin/pref/check.gif");
        }
        li.appendChild(lc);
    }
    accountListbox.selectedIndex = 0;
}

function openAccountPrefsDialog()
{
    var selectedItem = document.getElementById("delicious-prefs-accounts-list").selectedItem;
    var user = selectedItem.value;
    window.openDialog("chrome://delicious/content/prefUserDialog.xul", "", "chrome, modal", userPrefsChanged, user);
}

function usernameIsInUse(username, addingUser)
{
    if (addingUser && userManager.getUsers().length == 0) {
        return false;
    }
    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    var li = accountListbox.getItemAtIndex(0);
    while (li != null) {
        if (li.value == username && (addingUser || accountListbox.getIndexOfItem(li) != accountListbox.selectedIndex)) {
            alert("Usernames must be unique.\nAccount '"+userManager.getAccountNameForUser(username)+"' already uses this username.");
            return true;
        }
        li = accountListbox.getNextItem(li, 1);
    }
    return false;
}

//
// Callback for prefUserDialog.xul's onAccept.
// Arguments:
//   - prefs[0] - new username
//   - prefs[1] - new password
//   - prefs[2] - new account name
// Return true if ok to close prefUserDialog, false otherwise.
//
function userPrefsChanged(prefs)
{
    if (usernameIsInUse(prefs[0], false)) {
        return false;
    }
    var selectedItem = document.getElementById("delicious-prefs-accounts-list").selectedItem;
    var oldUsername = selectedItem.value;
    var oldDefaultUser = userManager.getDefaultUser();
    selectedItem.label = prefs[2];
    selectedItem.value = prefs[0];
    if (prefs[0] == oldUsername) {
        userManager.setAccountNameForUser(prefs[0], prefs[2]);
        userManager.setPasswordForUser(prefs[0], prefs[1]);
    } else {
        userManager.deleteUser(oldUsername);
        userManager.createUser(prefs[0], prefs[1], prefs[2]);
        if (oldDefaultUser != userManager.getDefaultUser()) {
            markNewDefaultUser(prefs[0], oldDefaultUser);
        }
    }
    if (oldUsername == oldDefaultUser) {
        userManager.setDefaultUser(prefs[0]);
    }
    return true;
}

function markNewDefaultUser(newDefaultUser, oldDefaultUser)
{
    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    var li = accountListbox.getItemAtIndex(0);
    while (li != null) {
        lc = li.childNodes.item(0);
        if (li.value == newDefaultUser) {
            lc.setAttribute("image", "chrome://mozapps/skin/pref/check.gif");
        } else if (li.value == oldDefaultUser) {
            lc.setAttribute("image", "");
        }
        li = accountListbox.getNextItem(li, 1);
    }
}

function setDefaultAccount()
{
    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    var selectedUser = accountListbox.selectedItem.value;
    var previousDefaultUser = userManager.getDefaultUser();

    userManager.setDefaultUser(selectedUser);
    
    var currentDefaultUser = userManager.getDefaultUser();
    if (currentDefaultUser != previousDefaultUser) {
        markNewDefaultUser(selectedUser, previousDefaultUser);
    }
}

function addAccount()
{
    window.openDialog("chrome://delicious/content/prefUserDialog.xul", "", "chrome, modal", accountInfoEntered, '');
}

//
// Callback for prefUserDialog.xul's onAccept.
// Arguments:
//   - prefs[0] - new username
//   - prefs[1] - new password
//   - prefs[2] - new account name
// Return true if ok to close prefUserDialog, false otherwise.
//
function accountInfoEntered(prefs)
{
    if (usernameIsInUse(prefs[0], true)) {
        return false;
    }
    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    var li = accountListbox.appendItem(prefs[2], prefs[0]);
    var lc = document.createElement('listcell');
    lc.setAttribute("class", "listcell-iconic");
    li.appendChild(lc);
    userManager.createUser(prefs[0], prefs[1], prefs[2]);
    markNewDefaultUser(userManager.getDefaultUser(), '');
    return true;
}

function deleteAccount()
{
    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    if (!accountListbox.selectedItem) {
        return;
    }
    userManager.deleteUser(accountListbox.selectedItem.value);
    markNewDefaultUser(userManager.getDefaultUser(), '');
    accountListbox.removeChild(accountListbox.selectedItem);
}

function cookieClicked()
{
    document.getElementById("delicious-prefs-experimental").disabled ^= true;
    document.getElementById("delicious-prefs-experimental").checked = false;
}
